// Prototype de la fonction
void apd(void);

// Rglage de l'APD
void apd(void)
{
	// L'image de la bote de dialogue
	#include "boite.h"

	//Dclaration des variables locales.
	// Sprite du curseur
	unsigned char curs[8]={ 0xF8, 0xD8, 0x0, 0xD8, 0xD8, 0x0, 0xD8, 0xF8};

	char *screensave=NULL;
	char b[13];
	short key, init, lcd_height,lcd_width,x;
	unsigned short apd;
	SCR_RECT screen;
	//Fin de la dclaration des variables locales.

	//Initialisation des variables locales.
	if (!(screensave=(char*)malloc(3841*sizeof(char)))) return;
	LCD_save(screensave);
	init=OSInitBetweenKeyDelay(10);
	apd=OSTimerCurVal(APD_TIMER)/20;			//Rcupration de la valeur de l'apd.
	if (apd>999) apd=999;
	if (apd<10) apd=10;
	lcd_height=128/2;					//Centre de l'cran en hauteur.
	lcd_width=240/2;					//Centre de l'cran en largeur.
	screen.xy.x0=lcd_width-89;
	screen.xy.y0=lcd_height-36;
	screen.xy.x1=lcd_width+89;
	screen.xy.y1=lcd_height+36;
	//Fin de l'initialisation des variables locales.

	// Affichage de la boite de dialogue
	BitmapPut(lcd_width-88, lcd_height-35, &dialogue, &screen, A_REPLACE);

	// On utilise la police moyenne
	FontSetSys(1);

	//Boucle principale du programme.
	do
	{
		sprintf(b,"%03d secondes",apd);		//Formatage de la chane de caractres.

		// Dcalge du curseur vers la droite
		x=(short)((apd/10)-1);

		// On affiche le curseur
		Sprite8(lcd_width-56+x, lcd_height-18, 8, curs, LCD_MEM, SPRT_XOR);

		// On affiche le nombre de secondes
		DrawStrXY(lcd_width-3*strlen(b),lcd_height-3,b,A_REPLACE);

		// Mmorisation de la touche appuye
		while((key=ngetchx())!=340 && key!=337 && key!=13 && key!=264);

		if (key==340 && apd<=998)
		{
			apd++;	//Si on appuis sur [DROITE].
		}
		if (key==337 && apd>=11)
		{
			apd--;	//Si on appui sur [GAUCHE].
		}
		// On efface le curseur
		Sprite8(lcd_width-56+x, lcd_height-18, 8, curs, LCD_MEM, SPRT_XOR);
	}
	while (key!=264 && key!=13);			//Si on appui sur [ESC] ou [ENTER].
	//Fin de la boucle principale.

	//Enregistrement de la nouvelle valeur de l'APD si on a appuy sur [ENTER].
	if (key==13)
	{
		OSFreeTimer(APD_TIMER);					//Libration du timer corespondant l'APD.
		OSRegisterTimer(APD_TIMER, apd*20);	//Enregistrement de la nouvelle valeur.
	};
	OSInitBetweenKeyDelay(init);
	LCD_restore(screensave);
	free(screensave);
	//Fin de l'enregistrement de la nouvelle valeur de l'APD si on a appuy sur [ENTER].
}
